;(() => {
  const frameUrl = new URL(location.href)

  let configString = frameUrl.searchParams.get('c')
  if (!configString) return

  let config = configString
  try {
    config = JSON.parse(atob(config))
  } catch {
    return
  }

  let { url, engineName, vua, vlang } = config
  if (!url || !engineName) return

  chrome.tabs.getCurrent(tab => {
    config.frameName = `${config.engineName}:${tab.id}`
    delete config.url

    window.name = btoa(JSON.stringify(config))

    url = new URL(url)
    if (vua) url.searchParams.set('_vua', vua)
    if (vlang) url.searchParams.set('_vlang', vlang)
    location.href = url.href
  })
})()
